import { renderless, api } from '@opentinyvue/vue-renderless/floating-button/vue';
import { defineComponent, props, setup } from '@opentinyvue/vue-common';
import { iconPlus } from '@opentinyvue/vue-icon';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

var __vue2_script = defineComponent({
  emits: ["click"],
  props: [].concat(props, ["position", "backgroundColor", "icon", "resetTime", "animated", "expandList", "isExpand", "vague", "mask", "elementSelector"]),
  components: {
    IconPlus: iconPlus()
  },
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    attrs: {
      "data-tag": "tiny-floating-button-body"
    }
  }, [_vm.vague || _vm.mask ? _c("div", {
    class: ["w-screen h-screen fixed top-0 bottom-0 left-0 right-0", {
      "bg-color-fill-5 backdrop-blur-md": _vm.vague
    }, {
      "bg-black opacity-30": _vm.mask
    }],
    attrs: {
      "data-tag": "tiny-floating-button-mask"
    }
  }) : _vm._e(), _c("div", {
    class: ["rounded-full fixed bottom-11 leading-none", _vm.position === "center" ? "" : _vm.position === "left" ? !_vm.state.specialHiddenSpace && "left-3" : "right-3"],
    style: _vm.state.style,
    attrs: {
      "data-tag": "tiny-floating-button"
    }
  }, [_c("button", {
    ref: "floatingButton",
    class: _vm.m("w-11 h-11 p-3 rounded-full", _vm.state.disabled ? "text-color-text-disabled bg-color-bg-3 border-transparent active:cursor-not-allowed" : _vm.backgroundColor === "white" ? "bg-color-bg-1" : "text-color-bg-1 bg-color-brand"),
    attrs: {
      "data-tag": "tiny-floating-button-main"
    },
    on: {
      "click": function click($event) {
        return _vm.handleClick($event, 0);
      }
    }
  }, [_c(_vm.icon, {
    tag: "component",
    class: _vm.m("w-5 h-5 rotate-0 transition-transform duration-300 will-change-transform", _vm.state.disabled ? "fill-color-icon-disabled active:cursor-not-allowed" : _vm.backgroundColor === "white" ? "fill-color-icon-secondary" : "fill-color-bg-1", {
      "rotate-45": _vm.state.isExpand
    }),
    attrs: {
      "data-tag": "tiny-floating-button-icon"
    }
  })], 1), _vm.state.expandList && _vm.state.expandList.length >= 1 ? _c("div", {
    class: _vm.m("absolute -bottom-5 -mb-0.5 -left-0.5 -z-10 transition-bottom ease-linear duration-100 cursor-pointer", {
      "bottom-18 [&_span]:opacity-100 [&_span]:visible": _vm.state.isExpand && _vm.position === "right"
    }, {
      "bottom-16 -mb-1 [&_span]:opacity-100 [&_span]:visible": _vm.state.isExpand && _vm.position === "center"
    }, {
      "bottom-18 [&_span]:opacity-100 [&_span]:visible": _vm.state.isExpand && _vm.position === "left"
    }),
    attrs: {
      "data-tag": "tiny-floating-button-expand-first"
    },
    on: {
      "click": function click($event) {
        return _vm.handleClick($event, 1);
      }
    }
  }, [_c("button", {
    class: _vm.m("w-11 h-11 rounded-full mx-0.5", _vm.state.disabled ? "text-color-text-disabled bg-color-bg-3 border-transparent active:cursor-not-allowed" : "bg-color-info-primary-subtler")
  }, [_c(_vm.state.expandList && _vm.state.expandList[0].icon, {
    tag: "component",
    class: ["w-5 h-5", _vm.state.disabled ? "fill-color-icon-disabled active:cursor-not-allowed" : "fill-color-brand"],
    attrs: {
      "data-tag": "tiny-floating-button-icon"
    }
  })], 1), _c("span", {
    class: ["text-center mt-0.5 text-xs w-12 leading-5 block opacity-0 transition-opacity ease-linear duration-100 invisible", !_vm.mask ? "text-color-fill-primary" : "text-color-bg-1"]
  }, [_vm._v(_vm._s(_vm.state.expandList && _vm.state.expandList[0].title))])]) : _vm._e(), _vm.state.expandList && _vm.state.expandList.length >= 2 ? _c("div", {
    class: _vm.m("absolute -bottom-5 -mb-0.5 -left-0.5 -z-10 transition-bottom ease-linear duration-100 cursor-pointer", {
      "-left-18 bottom-11 mb-0 [&_span]:opacity-100 [&_span]:visible": _vm.state.isExpand && _vm.position === "right"
    }, {
      "-left-18 right-auto bottom-4.5 mb-0 [&_span]:opacity-100 [&_span]:visible": _vm.state.isExpand && _vm.position === "center"
    }, {
      "left-18 right-auto bottom-11 mb-0 [&_span]:opacity-100 [&_span]:visible": _vm.state.isExpand && _vm.position === "left"
    }),
    attrs: {
      "data-tag": "tiny-floating-button-expand-second"
    },
    on: {
      "click": function click($event) {
        return _vm.handleClick($event, 2);
      }
    }
  }, [_c("button", {
    class: _vm.m("w-11 h-11 rounded-full mx-0.5", _vm.state.disabled ? "text-color-text-disabled bg-color-bg-3 border-transparent active:cursor-not-allowed" : "bg-color-success-subtler")
  }, [_c(_vm.state.expandList && _vm.state.expandList[1].icon, {
    tag: "component",
    class: ["w-5 h-5", _vm.state.disabled ? "fill-color-icon-disabled active:cursor-not-allowed" : "fill-color-success-active"],
    attrs: {
      "data-tag": "tiny-floating-button-icon"
    }
  })], 1), _c("span", {
    class: ["text-center text-xs mt-0.5 w-12 leading-5 block opacity-0 transition-opacity ease-linear duration-100 invisible", !_vm.mask ? "text-color-fill-primary" : "text-color-bg-1"]
  }, [_vm._v(_vm._s(_vm.state.expandList && _vm.state.expandList[1].title))])]) : _vm._e(), _vm.state.expandList && _vm.state.expandList.length >= 3 ? _c("div", {
    class: _vm.m("absolute -bottom-5 -mb-0.5 -left-0.5 -z-10 transition-bottom ease-linear duration-100 cursor-pointer", {
      "-left-18 -bottom-9 -mb-1 [&_span]:opacity-100 [&_span]:visible": _vm.state.isExpand && _vm.position === "right"
    }, {
      "left-18 right-auto bottom-4.5 mb-0 [&_span]:opacity-100 [&_span]:visible": _vm.state.isExpand && _vm.position === "center"
    }, {
      "left-18 -bottom-9 -mb-1 right-auto [&_span]:opacity-100 [&_span]:visible": _vm.state.isExpand && _vm.position === "left"
    }),
    attrs: {
      "data-tag": "tiny-floating-button-expand-third"
    },
    on: {
      "click": function click($event) {
        return _vm.handleClick($event, 3);
      }
    }
  }, [_c("button", {
    class: _vm.m("w-11 h-11 rounded-full mx-0.5", _vm.state.disabled ? "text-color-text-disabled bg-color-bg-3 border-transparent active:cursor-not-allowed" : "bg-color-warning-subtler")
  }, [_c(_vm.state.expandList && _vm.state.expandList[2].icon, {
    tag: "component",
    class: ["w-5 h-5", _vm.state.disabled ? "fill-color-icon-disabled active:cursor-not-allowed" : "fill-color-alert-hover"],
    attrs: {
      "data-tag": "tiny-floating-button-icon"
    }
  })], 1), _c("span", {
    class: ["text-center text-xs mt-0.5 w-12 leading-5 block opacity-0 transition-opacity ease-linear duration-100 invisible", !_vm.mask ? "text-color-fill-primary" : "text-color-bg-1"]
  }, [_vm._v(_vm._s(_vm.state.expandList && _vm.state.expandList[2].title))])]) : _vm._e()])]);
};
var staticRenderFns = [];
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, render, staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var mobileFirst = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { mobileFirst as default };
